<?php

define("THEME_VERSION", "0.0.1"); # remeber to update style.css
define("THEME_INCLUDE_VERSION", null); #null in developent


if ( ! function_exists( 'CreateTheme' ) ) :
function CreateTheme() {
	
	add_theme_support( 'html5', array("style", "script", "gallery", "caption", "search-form", "comment-form", "comment-list", ) );
    
    if(is_plugin_active("woocommerce"))
    {
        add_theme_support( 'woocommerce' );
        $pageId = get_option( 'woocommerce_shop_page_id' );
        $page = get_post($pageId);
        
        add_filter("template-redirects", function($pages){
            $pages["shop"] = (object)[
                "id"=> $pageId, 
                "slug"=>$page->post_name,
            ];
            return $pages;
        });
    }
    
}
endif;


function MT_GenerateNavLinks($data)
{
    $fileLocations = get_stylesheet_directory(). "/page-templates/";
    $projectFiles = scandir($fileLocations);
    
    $fileData = apply_filters("page_data", array()) ?? array();
    
    for($i=0; $i<count($projectFiles); $i++)
    {
        $page = $projectFiles[$i];
        $found = false;
        $order = 10;
        
        if($page == "." || $page == "..")
            continue;
        
        $pageSlug = null;
        if(preg_match("/page-(.*).php/", $page, $pageSlug))
             $pageSlug = $pageSlug[1];
         
        
        for($j=0; $j<count($fileData); $j++){
            
            if($fileData[$j]->page == $pageSlug)
            {
                $found = $fileData[$j];
                break;
            }
        }
        
        $separator = "-";
        $pageName = str_replace($separator, ' ', ucwords($pageSlug, $separator));
        
        $data = (object) array(
            "slug"=>$pageSlug, 
            "name"=>$pageName,
        );
        
        if($found !== false)
        {
            if($found->ignore ?? false)
                continue;
            
            if(isset($found->slug))
                $data->slug = $found->slug;
            
            if(isset($found->name))
                $data->name = $found->name;
            
            if(isset($found->order))
                $order = $found->order;
        }
        
        
        
        add_filter("theme_navigation_links", function($links)use($data){
            $links[] = $data;
            return $links;
        }, $order);
        
    }

}


add_filter("page_data", function($files){
    
    $files[] = (object)["page"=>"home", "slug"=>""];
    
    /*$files[] = (object)[
        "page"=>"another",      # refrence to page-another.php file in page-templates/ folder, requried.
        "name"=>"Another",      # The link visible text, slug will be converted to Readable Case by default
        "order"=>20      ,      # what order the link are in, 10 is default value.
        "slug" =>"another-page" # ovverides slug to use in link, will use "page" as defualt value
        "ignor" => false        # dont include this file in the navbar, default is false;
    ]; */
    return $files;
});




require_once("functions-admin.php");
require_once("functions-theme.php");
require_once("functions-load.php");


add_action( "after_setup_theme", "CreateTheme" );

add_action("wp", "MT_GenerateNavLinks");

add_action("wp_enqueue_scripts", function(){
    wp_enqueue_style("mt_structure", get_stylesheet_directory_uri(). "/styles/structure.css", array(), THEME_INCLUDE_VERSION);
});


function my_theme_archive_title( $title ) {
    if ( is_category() ) {
        $title = single_cat_title( '', false );
    } elseif ( is_tag() ) {
        $title = single_tag_title( '', false );
    } elseif ( is_author() ) {
        $title = '<span class="vcard">' . get_the_author() . '</span>';
    } elseif ( is_post_type_archive() ) {
        $title = post_type_archive_title( '', false );
    } elseif ( is_tax() ) {
        $title = single_term_title( '', false );
    }
 
    return $title;
}

add_filter( 'get_the_archive_title', 'my_theme_archive_title' );




function IndentedOuptut($functionName, $count=1, $skipFirst=true, $newLine=true){
    ob_start();
    call_user_func($functionName);
    $content = ob_get_clean();
    
    $lines = explode("\n", rtrim($content));
    
    for($i=0; $i<count($lines); $i++)
    {	
    	echo $skipFirst && $i==0 ? "" : str_repeat("\t", $count);
    	echo trim($lines[$i]);
    	echo !$newLine && $i==count($lines)-1 ? "" : "\n";
    }
    
}